<?php
/**
 * Copyright  2015 Inchoo d.o.o.
 * created by Zoran Salamun(zoran.salamun@inchoo.net)
 */
 
 
namespace Idealcheckout\Payment\Controller\Payment;
use Magento\Framework\Controller\ResultFactory;


 
$sRootPath = dirname(__FILE__);

while((strlen($sRootPath) > 2) && !is_dir($sRootPath . '/idealcheckout'))
{
	$sRootPath = dirname($sRootPath);
}

if(!is_dir($sRootPath . '/idealcheckout'))
{
	die('Cannot find /idealcheckout/ folder.<br>File: ' . __FILE__ . '<br>Line: ' . __LINE__);
}

require_once($sRootPath . '/idealcheckout/includes/library.php');
 



class Notify  extends \Magento\Framework\App\Action\Action
{
	/**
     * @var OrderSender
     */
	protected $orderSender;
	
	/**
     * @var invoiceSender
     */
	protected $invoiceSender;
	
	protected $scopeConfig;
		
	public function __construct(\Magento\Framework\App\Action\Context $context,
								\Magento\Sales\Model\Order\Email\Sender\OrderSender $orderSender,
								\Magento\Sales\Model\Order\Email\Sender\InvoiceSender $invoiceSender,
								\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
								)
    {
        parent::__construct($context);
		$this->orderSender = $orderSender;
		$this->invoiceSender = $invoiceSender;
		$this->scopeConfig = $scopeConfig;
    }
	
    public function execute()
    {
		$sOrderId = $this->getRequest()->getParam('order_id');
		$sOrderCode = $this->getRequest()->getParam('order_code');
				
		// Load Order
		$oOrder = $this->_objectManager->create('Magento\Sales\Model\Order')->loadByIncrementId($sOrderId);
		
		// Load database settings
		$aDatabaseSettings = idealcheckout_getDatabaseSettings();
		
		$sql = "SELECT * FROM `" . $aDatabaseSettings['table'] . "` WHERE (`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "') AND (`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "') ORDER BY `id` DESC LIMIT 1;";
		$aRecord = idealcheckout_database_getRecord($sql);
		
		
		// See if record is available
		if(isset($aRecord['transaction_status'])) // if(sizeof($oRecordset))
		{
			$sTransactionStatus = $aRecord['transaction_status'];
			
			if(in_array($sTransactionStatus, array('SUCCESS')))
			{
				$oPayment = $oOrder->getPayment();
				$oPayment->setTransactionId($aRecord['transaction_id']);
				$oPayment->setCurrencyCode($oOrder->getBaseCurrencyCode());
				$oPayment->setPreparedMessage('Order status from Idealcheckout: ' . $sTransactionStatus);
				$oPayment->setIsTransactionClosed(1);
				$oPayment->registerCaptureNotification($aRecord['transaction_amount']);
				$oOrder->save();
				
				// Check if the email has not been sent
				if(!$oOrder->getEmailSent()) 
				{
					$this->orderSender->send($oOrder);
				}

				// Sending invoice
				if($oOrder->canInvoice())
				{
					$oInvoice = $oPayment->getCreatedInvoice();
					
					if($oInvoice != null)
					{
						$this->invoiceSender->send($oInvoice);
					}
				}
				
				$sSuccessStatus = $this->scopeConfig->getValue('idealcheckout/general/successpayment', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
				$oOrder->addStatusToHistory($sSuccessStatus, 'Order status has changed', false);
				
			}
			elseif(strcasecmp($sTransactionStatus, 'PENDING') === 0)
			{
				$oOrder->hold()->save();
			}
			else
			{
				$oOrder->registerCancellation('Order status from iDEAL Checkout: ' . $sTransactionStatus)->Save();
				
			}			
		}
		
		
		exit('Callback successfully processed!');
	}
}